// ---------------------------------------------------------------------------
// Created by Francisco Malpartida on 16/04/11.
// Copyright 2011 - Under creative commons license:
//        Attribution-NonCommercial-ShareAlike CC BY-NC-SA
//
// This software is furnished "as is", without technical support, and with no 
// warranty, express or implied, as to its usefulness for any purpose.
//
// Thread Safe: No
// Extendable: Yes
//
// @file lm75.H
// File description here
// 
// @brief <very brief class description>
//
// @author F. Malpartida
// ---------------------------------------------------------------------------
#ifndef _LM75_H
#define _LM75_H


// Include header files
// ---------------------------------------------------------------------------
#include "Arduino.h"
#include <inttypes.h>
#include "thermistor.h"


// declarations - constants, variables and types
// ---------------------------------------------------------------------------

// CLASS
// ---------------------------------------------------------------------------
class lm75 : public thermistor
{
public:   
   // Constructors:
   lm75( uint8_t address);   
   lm75 ( void );
   
   // Destructor:
   ~lm75();
   
   // Functions: modifiers (set), selectors (get)
   void init ( void );             // From virtual parent class
   int modeSet ( t_mode );         // From virtual parent class
   float readTemperature ( void ); // From virtual parent class
   bool isAvailable ( void );      // From virtual parent class

   uint8_t addressGet ( void );
   void addressSet ( uint8_t );
   t_mode modeGet ( void );
   
   // itterators:
   // Attributes visible by scope of instantiation and use

protected:
   // Attributes visible to descendents
   
private:
   // Local attributes
   uint8_t _address;   // Address on the I2C
   t_mode  _mode;      // Thermistor Status
   boolean _available; // Indicates if the thermistor at the address is available
   uint8_t _confReg;   // Configuration register
   
   // Private class methods
   int configureNormalMode ( );
   int readRaw ( int & );
   int configureShutdownMode ( );
};

// inline function definitions
// ---------------------------------------------------------------------------
#endif  // _LM75_H




